C changes 21.12.01: all VEC_$DMULT etc.replaced by VEC_DMULT 
C since new compiler does not accept it
C*****************************************************
C FONCTION P3DI+P4DI
C*****************************************************	
C*****************************************************
C PARTIE FINIE POUR PT5 > PTM
C*****************************************************
c part prop. Log(R^2) in 5||3
C*****************************************************
	SUBROUTINE SSY3R(S,GPT,X10,X20,PTM,R,Y3,Y4,IH2,SY3R)
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=2)
	DIMENSION PART35R(K0MAX),SF(K0MAX)
	DIMENSION SY3R(K0MAX),TEMP(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
c attention les elements de matrice 2 -> 2 sont independant de 
c l'echelle d'energie
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*GPT*DEXP(Y4)
	UC = -X10*DSQRT(S)*GPT*DEXP(-Y4)
	ZM = (GPT-PTM)/GPT
	CALL STRFRAD(X10,X20,IH2,SF)
	CALL SPART35RD(SC,TC,UC,ZM,R,PART35R)
	TYU = GPT
	CALL VEC_DMULT_VECTOR(SF,PART35R,K0MAX,TEMP)
	CALL VEC_DMULT_CONSTANT(TEMP,K0MAX,TYU,SY3R)
	RETURN
	END
C**********************************************************************
c part prop. Log(R^2) in 5||4
C**********************************************************************
	SUBROUTINE SSY4R(S,GPT4,X10,X20,Z4,R,Y3,Y4,IH2,SY4R)
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=2)
	DIMENSION PART45R(K0MAX),SF(K0MAX)
	DIMENSION SY4R(K0MAX),TEMP(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	PT4 = GPT4
	X1S = X10/Z4
	X2S = X20/Z4
	if (x1s.gt.un.or.x2s.gt.un) then
	  CALL VEC_DINIT(SY4R,K0MAX,ZERO)
	  return
	endif
c attention les elements de matrice 2 -> 2 sont independant de 
c l'echelle d'energie
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*PT4*DEXP(Y4)
	UC = -X10*DSQRT(S)*PT4*DEXP(-Y4)
	CALL STRFRAD(X1S,X2S,IH2,SF)
	CALL SPART45RD(SC,TC,UC,Z4,R,PART45R)
	TYU = GPT4/Z4**2
	CALL VEC_DMULT_VECTOR(SF,PART45R,K0MAX,TEMP)
	CALL VEC_DMULT_CONSTANT(TEMP,K0MAX,TYU,SY4R)
	RETURN
	END
C*****************************************************
C FONCTIONS POUR P3DI+P4DI	
C*****************************************************	
C soft (z1=1,z2=1) part of 5||1, 5||2 and part of virtual 	
C*****************************************************	
	SUBROUTINE SSV12(S,GPT3,GPT4,PTM,Y3,Y4,X10,X20,M,MU,
     #	IH2,SV12)
C INTEGRALE A 1 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUP/PTMM,R
	COMMON/FLAG/ICOUP
	PARAMETER (K0MAX=2)
	DIMENSION PART15Z(K0MAX),PART15L(K0MAX),PART15D(K0MAX)
	DIMENSION PART25Z(K0MAX),PART25L(K0MAX),PART25D(K0MAX)
	DIMENSION PARTVI(K0MAX),SF(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	DIMENSION AU1(K0MAX),AU2(K0MAX),AU3(K0MAX),SV12(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	X3MIN = 2.D0*GPT3/DSQRT(S)*DCOSH(Y3)
	PT3 = GPT3
	PT4 = PT3
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	CALL STRFRAD(X10,X20,IH2,SF)
	CALL SPART15ZD(SC,TC,UC,UN,M,PTM,PART15Z)
	CALL SPART15LD(SC,TC,UC,UN,PART15L)
	CALL SPART15DD(SC,TC,UC,M,PTM,PART15D)
	CALL SPART25ZD(SC,TC,UC,UN,M,PTM,PART25Z)
	CALL SPART25LD(SC,TC,UC,UN,PART25L)
	CALL SPART25DD(SC,TC,UC,M,PTM,PART25D)
	CALL SPARTVID(S,SC,TC,UC,MU,PT3,PTM,PARTVI)
C
	CALL VEC_DMULT_VECTOR(PART15Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART15L,SF,K0MAX,TEMP1)
	CALL VEC_DMULT_VECTOR(PART15D,SF,K0MAX,TEMP2)
	TY1 = DLOG(1-X10)
	TY2 = DLOG(1-X10)**2/2.D0
	CALL VEC_DMULT_ADD(TEMP2,TEMP1,K0MAX,TY2,TEMP3)
	CALL VEC_DMULT_ADD(TEMP3,TEMP0,K0MAX,TY1,AU1)
C
	CALL VEC_DMULT_VECTOR(PART25Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART25L,SF,K0MAX,TEMP1)
	CALL VEC_DMULT_VECTOR(PART25D,SF,K0MAX,TEMP2)
	TY1 = DLOG(1-X20)
	TY2 = DLOG(1-X20)**2/2.D0
	CALL VEC_DMULT_ADD(TEMP2,TEMP1,K0MAX,TY2,TEMP3)
	CALL VEC_DMULT_ADD(TEMP3,TEMP0,K0MAX,TY1,AU2)
C
	CALL VEC_DMULT_VECTOR(PARTVI,SF,K0MAX,AU3)
C
	CALL VEC_DADD_VECTOR(AU1,AU2,K0MAX,TEMP0)
	TY3 = GPT3
	CALL VEC_DADD_MULT_CONSTANT(TEMP0,AU3,K0MAX,TY3,SV12)
	RETURN
	END
C*****************************************************	
c part prop. H34(0) in sigma^ir
C*****************************************************	
	SUBROUTINE SSV2(S,GPT3,Y3,Y4,X10,X20,U1,IH2,SV2)
C INTEGRALE A 2 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUP/PTM,R
	COMMON/FLAG/ICOUP
	PARAMETER (K0MAX=2)
	DIMENSION PARTVI2(K0MAX),SF(K0MAX)
	DIMENSION SV2(K0MAX),TEMP0(K0MAX)
	PI=4.D0*DATAN(1.D0)
	ZERO = 0.D0
	UN = 1.D0
	FI = PI*U1
	PT3 = GPT3
	PT4 = PT3
	YS = (Y3-Y4)/2.D0
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	CALL STRFRAD(X10,X20,IH2,SF)
	CALL SPARTVI2D(S,SC,TC,UC,YS,FI,PARTVI2)
	CALL VEC_DMULT_VECTOR(PARTVI2,SF,K0MAX,TEMP0)
	TY = GPT3*PI
	CALL VEC_DMULT_CONSTANT(TEMP0,K0MAX,TY,SV2)
	RETURN
	END
C*****************************************************
C 5||3 except Log(R^2) part
C****************************************************	
	SUBROUTINE SSV3(S,GPT,Y3,Y4,X10,X20,IH2,SV3)
C INTEGRALE A 1 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=2)
	DIMENSION PART35D(K0MAX),SF(K0MAX)
	DIMENSION SV3(K0MAX),AU3(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
c
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*GPT*DEXP(Y4)
	UC = -X10*DSQRT(S)*GPT*DEXP(-Y4)
	CALL STRFRAD(X10,X20,IH2,SF)
	CALL SPART35DD(SC,TC,UC,PART35D)
	CALL VEC_DMULT_VECTOR(PART35D,SF,K0MAX,AU3)
	TY3 = GPT
	CALL VEC_DMULT_CONSTANT(AU3,K0MAX,TY3,SV3)
	RETURN
	END
C*****************************************************	
C soft part (z4=1) of 5||4
C***************************************************** 	
	SUBROUTINE SSV4(S,GPT4,GPT3SUP,PTM,Y3,Y4,X10,X20,MF,IH2,SV4)
C INTEGRALE A 1 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUP/PTMM,R
	COMMON/AURENCHE/IAUREN
	PARAMETER (K0MAX=2)
	DIMENSION PART45Z(K0MAX),PART45L(K0MAX),PART45D(K0MAX),SF(K0MAX)
	DIMENSION SV4(K0MAX),AU4(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	PT4 = GPT4
	PT3 = PT4
C
	X4MIN = 2.D0*GPT4*DCOSH(Y4)/DSQRT(S)
	Z4MAX0 = 1.D0
	Z4SUP = PT4/(PTM+PT4)	
	Z4MINpre = DMAX1(X4MIN,GPT4/GPT3SUP,X10,X20)
c changed! (to avoid z4min=1)	  
	  Z4MIN = DMIN1(Z4MINpre,0.9999D0)	
	  Z4MAX = Z4MAX0	
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*PT4*DEXP(Y4)
	UC = -X10*DSQRT(S)*PT4*DEXP(-Y4)
** 	IF (IAUREN.EQ.1) THEN
** 	  MF = DSQRT(SC)
** 	ENDIF
	CALL STRFRAD(X10,X20,IH2,SF)
	CALL SPART45ZD(SC,TC,UC,UN,MF,PT4,PART45Z)
	CALL SPART45LD(SC,TC,UC,UN,PART45L)
	CALL SPART45DD(SC,TC,UC,MF,PT4,PART45D)
	CALL VEC_DMULT_VECTOR(PART45Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART45L,SF,K0MAX,TEMP1)
	CALL VEC_DMULT_VECTOR(PART45D,SF,K0MAX,TEMP2)
	TY1 = DLOG(1-Z4MIN)
	TY2 = DLOG(1-Z4MIN)**2/2.D0
	CALL VEC_DMULT_ADD(TEMP2,TEMP1,K0MAX,TY2,TEMP3)
	CALL VEC_DMULT_ADD(TEMP3,TEMP0,K0MAX,TY1,AU4)
	TY3 = GPT4
	CALL VEC_DMULT_CONSTANT(AU4,K0MAX,TY3,SV4)
	RETURN
	END
C*****************************************************	
C         5||1(z1) - 5||1(1)
C*****************************************************	
	SUBROUTINE SSY31(S,GPT3,Y3,Y4,X10,X20,M,U1,IH2,SY31)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUP/PTMM,R
	common/xele/xe
	PARAMETER (K0MAX=2)
	DIMENSION PART15Z(K0MAX),PART15L(K0MAX)
	DIMENSION PART15Z0(K0MAX),PART15L0(K0MAX)
	DIMENSION PART25Z(K0MAX),PART25L(K0MAX)
	DIMENSION PART25Z0(K0MAX),PART25L0(K0MAX)
	DIMENSION SF(K0MAX),SF0(K0MAX)
	DIMENSION SY31(K0MAX),BU1(K0MAX),BU2(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	DIMENSION TEMP4(K0MAX),TEMP5(K0MAX),TEMP6(K0MAX),TEMP7(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT3 = GPT3
	PT5X = DSQRT(S)/(2.D0*DCOSH(YS))*(1.D0-X10)*(1.D0-X20)/
     #  ((1.D0-X10)*DEXP(-Y)+(1.D0-X20)*DEXP(Y))
cc	PTM = DMIN1(PTMM,PT5X)
	PTM = PTMM
c
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	Z1MAX = 1.D0
	Z1MIN = X10
	Z1 = Z1MIN + (Z1MAX-Z1MIN)*U1
	xe=x10/z1
	CALL STRFRAD(X10/Z1,X20,IH2,SF)
	CALL STRFRAD(X10,X20,IH2,SF0)
	CALL SPART15ZD(SC,TC,UC,Z1,M,PTM,PART15Z)
	CALL SPART15ZD(SC,TC,UC,UN,M,PTM,PART15Z0)
	CALL SPART15LD(SC,TC,UC,Z1,PART15L)
	CALL SPART15LD(SC,TC,UC,UN,PART15L0)
	CALL VEC_DMULT_VECTOR(PART15Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART15Z0,SF0,K0MAX,TEMP1)
	TY1 = 1.D0/Z1**2
	CALL VEC_DMULT_SUB(TEMP1,TEMP0,K0MAX,TY1,TEMP2)
	TY2 = 1.D0/(1.D0-Z1)
	CALL VEC_DMULT_CONSTANT(TEMP2,K0MAX,TY2,TEMP3)
C
	CALL VEC_DMULT_VECTOR(PART15L,SF,K0MAX,TEMP4)
	CALL VEC_DMULT_VECTOR(PART15L0,SF0,K0MAX,TEMP5)
	CALL VEC_DMULT_SUB(TEMP5,TEMP4,K0MAX,TY1,TEMP6)
	TY3 = DLOG(1.D0-Z1)/(1.D0-Z1)
	CALL VEC_DMULT_CONSTANT(TEMP6,K0MAX,TY3,TEMP7)
C
	TY4 = (Z1MAX-Z1MIN)*GPT3
	CALL VEC_DADD_MULT_CONSTANT(TEMP3,TEMP7,K0MAX,TY4,SY31)
	RETURN
	END
C*****************************************************	
C     5||2(z2)-5||2(1)
C*****************************************************	
	SUBROUTINE SSY32(S,GPT3,Y3,Y4,X10,X20,M,U1,IH2,SY32)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUP/PTMM,R
	PARAMETER (K0MAX=2)
	DIMENSION PART15Z(K0MAX),PART15L(K0MAX)
	DIMENSION PART15Z0(K0MAX),PART15L0(K0MAX)
	DIMENSION PART25Z(K0MAX),PART25L(K0MAX)
	DIMENSION PART25Z0(K0MAX),PART25L0(K0MAX)
	DIMENSION SF(K0MAX),SF0(K0MAX)
	DIMENSION SY32(K0MAX),BU1(K0MAX),BU2(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	DIMENSION TEMP4(K0MAX),TEMP5(K0MAX),TEMP6(K0MAX),TEMP7(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT3 = GPT3
	PT5X = DSQRT(S)/(2.D0*DCOSH(YS))*(1.D0-X10)*(1.D0-X20)/
     #  ((1.D0-X10)*DEXP(-Y)+(1.D0-X20)*DEXP(Y))
cc	PTM = DMIN1(PTMM,PT5X)
	PTM = PTMM
c
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	Z2MAX = 1.D0
	Z2MIN = X20
	Z2 = Z2MIN + (Z2MAX-Z2MIN)*U1
	CALL STRFRAD(X10,X20/Z2,IH2,SF)
	CALL STRFRAD(X10,X20,IH2,SF0)
	CALL SPART25ZD(SC,TC,UC,Z2,M,PTM,PART25Z)
	CALL SPART25ZD(SC,TC,UC,UN,M,PTM,PART25Z0)
	CALL SPART25LD(SC,TC,UC,Z2,PART25L)
	CALL SPART25LD(SC,TC,UC,UN,PART25L0)
	CALL VEC_DMULT_VECTOR(PART25Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART25Z0,SF0,K0MAX,TEMP1)
	TY1 = 1.D0/Z2**2
	CALL VEC_DMULT_SUB(TEMP1,TEMP0,K0MAX,TY1,TEMP2)
	TY2 = 1.D0/(1.D0-Z2)
	CALL VEC_DMULT_CONSTANT(TEMP2,K0MAX,TY2,TEMP3)
C
	CALL VEC_DMULT_VECTOR(PART25L,SF,K0MAX,TEMP4)
	CALL VEC_DMULT_VECTOR(PART25L0,SF0,K0MAX,TEMP5)
	CALL VEC_DMULT_SUB(TEMP5,TEMP4,K0MAX,TY1,TEMP6)
	TY3 = DLOG(1.D0-Z2)/(1.D0-Z2)
	CALL VEC_DMULT_CONSTANT(TEMP6,K0MAX,TY3,TEMP7)
C
	TY4 = (Z2MAX-Z2MIN)*GPT3
	CALL VEC_DADD_MULT_CONSTANT(TEMP3,TEMP7,K0MAX,TY4,SY32)
C
	RETURN
	END
C*****************************************************
c 5||4(z4) - 5||4(1)
c*****************************************************		
	SUBROUTINE SSY4P(S,GPT4,X10,X20,Z4,Y3,Y4,MF,IH2,SY4P)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/AURENCHE/IAUREN
	PARAMETER (K0MAX=2)
	DIMENSION PART45Z(K0MAX),PART45L(K0MAX)
	DIMENSION PART45Z0(K0MAX),PART45L0(K0MAX),SF0(K0MAX)
	DIMENSION SF(K0MAX),SY4P(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	DIMENSION TEMP4(K0MAX),TEMP5(K0MAX),TEMP6(K0MAX),TEMP7(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	PT4 = GPT4
	X1S = X10/Z4
	X2S = X20/Z4
c en principe vrai mais a verif
	if (x1s.gt.un.or.x2s.gt.un) then
	  CALL VEC_DINIT(SY4P,K0MAX,ZERO)
	  write (18,*) 'attention  x1S > 1 ou x2S > 1',
     #		x1S,x2S
	  return
	endif
c attention les elements de matrice 2 -> 2 sont independant de 
c l'echelle d'energie
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*PT4*DEXP(Y4)
	UC = -X10*DSQRT(S)*PT4*DEXP(-Y4)
CC	SC = X1S*X2S*S
CC	TC = -X2S*DSQRT(S)*PT4/Z4*DEXP(Y4)
CC	UC = -X1S*DSQRT(S)*PT4/Z4*DEXP(-Y4)
** 	IF (IAUREN.EQ.1) THEN
** 	  MF = DSQRT(SC)
** 	ENDIF
	CALL STRFRAD(X1S,X2S,IH2,SF)
	CALL STRFRAD(X10,X20,IH2,SF0)
	CALL SPART45ZD(SC,TC,UC,Z4,MF,PT4,PART45Z)
	CALL SPART45ZD(SC,TC,UC,UN,MF,PT4,PART45Z0)
	CALL SPART45LD(SC,TC,UC,Z4,PART45L)
	CALL SPART45LD(SC,TC,UC,UN,PART45L0)
C
	CALL VEC_DMULT_VECTOR(PART45Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART45Z0,SF0,K0MAX,TEMP1)
	TY1 = 1.D0/Z4**2
	CALL VEC_DMULT_SUB(TEMP1,TEMP0,K0MAX,TY1,TEMP2)
	TY2 = 1.D0/(1.D0-Z4)
	CALL VEC_DMULT_CONSTANT(TEMP2,K0MAX,TY2,TEMP3)
C
	CALL VEC_DMULT_VECTOR(PART45L,SF,K0MAX,TEMP4)
	CALL VEC_DMULT_VECTOR(PART45L0,SF0,K0MAX,TEMP5)
	CALL VEC_DMULT_SUB(TEMP5,TEMP4,K0MAX,TY1,TEMP6)
	TY3 = DLOG(1.D0-Z4)/(1.D0-Z4)
	CALL VEC_DMULT_CONSTANT(TEMP6,K0MAX,TY3,TEMP7)
C
	TY4 = GPT4
	CALL VEC_DADD_MULT_CONSTANT(TEMP3,TEMP7,K0MAX,TY4,SY4P)
	RETURN
	END
C*****************************************************
C TERME A L'ORDRE DE BORN	
C*****************************************************	
	SUBROUTINE SFBORN(S,N,GPT3,Y3,Y4,IH2,FBORN)
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=2)
	DIMENSION SF1(K0MAX),RBORN1(K0MAX)
	DIMENSION FBORN(K0MAX),TEMP0(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT = GPT3
	X10 = 2.D0*PT/DSQRT(S)*DEXP(Y)*DCOSH(YS)	
	X20 = 2.D0*PT/DSQRT(S)*DEXP(-Y)*DCOSH(YS)
	if (x10.gt.un.or.x20.gt.un) then
	  CALL VEC_DINIT(FBORN,K0MAX,ZERO)
	  write (8,*) 'x10,x20    =',x10,x20 
	  return
	endif
	SC = 4.D0*PT**2*DCOSH(YS)**2
	TC = -2.D0*PT**2*DCOSH(YS)*DEXP(-YS)
	UC = -2.D0*PT**2*DCOSH(YS)*DEXP(YS)
	CALL STRFRAD(X10,X20,IH2,SF1)
c	write (8,*) 'SF1    =',SF1 
	CALL BORND(SC,TC,UC,N,RBORN1)
	CALL VEC_DMULT_VECTOR(RBORN1,SF1,K0MAX,TEMP0)
	TY3 = GPT3
	CALL VEC_DMULT_CONSTANT(TEMP0,K0MAX,TY3,FBORN)
	RETURN
	END
c
	SUBROUTINE GLGL_GAGA(S,N,GPT3,Y3,Y4,IH2,BOITE)
	IMPLICIT REAL*8 (A-H,L-Z)
	DIMENSION F2(-6:6)
	COMMON/SCALE/M,MF,MU
	UN = 1.D0
	VC = (N*N-1.D0)
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT = GPT3
	X10 = 2.D0*PT/DSQRT(S)*DEXP(Y)*DCOSH(YS)	
	X20 = 2.D0*PT/DSQRT(S)*DEXP(-Y)*DCOSH(YS)
	if (x10.gt.un.or.x20.gt.un) then
	  BOITE = 0.D0
	  return
	endif
	SC = 4.D0*PT**2*DCOSH(YS)**2
	TC = -2.D0*PT**2*DCOSH(YS)*DEXP(-YS)
	UC = -2.D0*PT**2*DCOSH(YS)*DEXP(YS)
C	CALL FSTRU(X10,M*M,IH1,F1)
	CALL GAMSTRU(X10,FG)
	CALL FSTRU(X20,M*M,IH2,F2)
	BOITE = GGPP(SC,TC,UC)*FG*F2(0)/(X10*X20)/(4.D0*VC)
	BOITE = BOITE*GPT3
	RETURN
	END 
C*****************************************************
C reaction gluon + gluon --> photon + photon
	DOUBLE PRECISION FUNCTION GGPP(SC,TC,UC)
	IMPLICIT REAL*8 (A-H,L-Z)
	DIMENSION QCHA(6)
	COMMON/GDF/JNF
	DATA QCHA/-1.D0,2.D0,-1.D0,2.D0,-1.D0,2.D0/
	PI=4.D0*DATAN(1.D0)
	SUMC = 0.D0
	DO I=1,JNF
	  SUMC = QCHA(I)**2 + SUMC
	ENDDO
	SUMC4 = SUMC**2/81.D0
      t0 = 256*(-1-(TC-UC)/SC*dlog(TC/UC)-(TC**2+UC**2)/SC**2*(dlog(TC/U
     #C)**2+Pi**2)/2)**2+256*(-1-(SC-UC)/TC*dlog(-SC/UC)-(SC**2+UC**2)/T
     #C**2*dlog(-SC/UC)**2/2)**2+256*Pi**2*((SC-UC)/TC+(SC**2+UC**2)/TC*
     #*2*dlog(-SC/UC))**2+256*(-1-(SC-TC)/UC*dlog(-SC/TC)-(SC**2+TC**2)/
     #UC**2*dlog(-SC/TC)**2/2)**2+256*Pi**2*((SC-TC)/UC+(SC**2+TC**2)/UC
     #**2*dlog(-SC/TC))**2+1280
     	GGPP = SUMC4*T0
	RETURN
	END
C*****************************************************				
c	
	SUBROUTINE XTHET(ZMAX,BSUP)
	IMPLICIT REAL*8 (A-H,L-Z)
	UN = 1.D0
	IF (ZMAX.EQ.UN) THEN
	  BSUP = UN
	ELSE IF (ZMAX.LT.UN) THEN
	  BSUP = 0.D0
	ENDIF
	RETURN
	END 
