C*****************************************************
C FONCTION P3DI+P4DI
C*****************************************************	
C*****************************************************
C PARTIE FINIE POUR PT5 > PTM
C*****************************************************
c part prop. Log(R^2) in 5||3
C*****************************************************
	SUBROUTINE SSY3RresO(S,GPT4,Y3,Y4,X10,X20,PTM,R,X4,
     #	IH1,IH2,IH4,ETA,SY3R)
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=32)
	DIMENSION PART35R(K0MAX),SF(K0MAX)
	DIMENSION SY3R(K0MAX),TEMP(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT4 = GPT4/X4
	PT3 = PT4
c attention les elements de matrice 2 -> 2 sont independant de 
c l'echelle d'energie
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	ZM = (PT3-PTM)/PT3
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL SPART35RresO(SC,TC,UC,ZM,R,PART35R)
	CALL VEC_DMULT_VECTOR(PART35R,SF,K0MAX,TEMP)
	TYU = 1.d0
	CALL VEC_DMULT_CONSTANT(TEMP,K0MAX,TYU,SY3R)
	RETURN
	END
C**********************************************************************
c part prop. Log(R^2) in 5||4
C**********************************************************************
c change 4.11.02
	SUBROUTINE SSY4RresO(S,GPT3,GPT4,Y3,Y4,R,X10,X20,Z4,IH1,IH2,
     #	IH4,ETA,SY4R)
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=32)
	DIMENSION PART45R(K0MAX),SF(K0MAX)
	DIMENSION SY4R(K0MAX),TEMP(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
        X4=GPT4/(Z4*GPT3)
	PT4 = GPT4/X4
c	X1S = X10/Z4
c	X2S = X20/Z4
c attention les elements de matrice 2 -> 2 sont independant de 
c l'echelle d'energie
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*GPT3*DEXP(Y4)
	UC = -X10*DSQRT(S)*GPT3*DEXP(-Y4)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL SPART45RresO(SC,TC,UC,Z4,R,PART45R)
c	TYU = GPT4/((X4*Z4)**2)
        TYU = 1.D0/Z4
	CALL VEC_DMULT_VECTOR(SF,PART45R,K0MAX,TEMP)
	CALL VEC_DMULT_CONSTANT(TEMP,K0MAX,TYU,SY4R)
	RETURN
	END
C*****************************************************
C FONCTIONS POUR P3DI+P4DI	
C*****************************************************
C soft (z1=1,z2=1) part of 5||1, 5||2 and part of virtual 	
C*****************************************************		
	SUBROUTINE SSV12resO(S,GPT4,Y3,Y4,M,MU,X10,X20,PTM,X4,IH1,
     #	IH2,IH4,ETA,SV12)
C INTEGRALE A 1 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
** 	COMMON/COUP/PTMM,R
	PARAMETER (K0MAX=32)
	DIMENSION PART15Z(K0MAX),PART15L(K0MAX),PART15D(K0MAX)
	DIMENSION PART25Z(K0MAX),PART25L(K0MAX),PART25D(K0MAX)
	DIMENSION PARTVI(K0MAX),SF(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	DIMENSION AU1(K0MAX),AU2(K0MAX),AU3(K0MAX),SV12(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT4 = GPT4/X4
	PT3 = PT4
** 	PT5X = DSQRT(S)/(2.D0*DCOSH(YS))*(1.D0-X10)*(1.D0-X20)/
**      #  ((1.D0-X10)*DEXP(-Y)+(1.D0-X20)*DEXP(Y))
** 	PTM = DMIN1(PTMM,PT5X)
cc	PTM = PTMM
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	V1 = X10/ETA
	CALL STRFRAPHO(V1,IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL SPART15ZresO(SC,TC,UC,UN,M,PTM,PART15Z)
	CALL SPART15LresO(SC,TC,UC,UN,PART15L)
	CALL SPART15DresO(SC,TC,UC,M,PTM,PART15D)
c	
	CALL SPART25ZresO(SC,TC,UC,UN,M,PTM,PART25Z)
	CALL SPART25LresO(SC,TC,UC,UN,PART25L)
	CALL SPART25DresO(SC,TC,UC,M,PTM,PART25D)
	CALL SPARTVIresO(S,SC,TC,UC,MU,PT3,PTM,PARTVI)
C
	CALL VEC_DMULT_VECTOR(PART15Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART15L,SF,K0MAX,TEMP1)
	CALL VEC_DMULT_VECTOR(PART15D,SF,K0MAX,TEMP2)
	TY1 = DLOG(1-V1)
	TY2 = DLOG(1-V1)**2/2.D0
	CALL VEC_DMULT_ADD(TEMP2,TEMP1,K0MAX,TY2,TEMP3)
	CALL VEC_DMULT_ADD(TEMP3,TEMP0,K0MAX,TY1,AU1)
C
	CALL VEC_DMULT_VECTOR(PART25Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART25L,SF,K0MAX,TEMP1)
	CALL VEC_DMULT_VECTOR(PART25D,SF,K0MAX,TEMP2)
	TY1 = DLOG(1-X20)
	TY2 = DLOG(1-X20)**2/2.D0
	CALL VEC_DMULT_ADD(TEMP2,TEMP1,K0MAX,TY2,TEMP3)
	CALL VEC_DMULT_ADD(TEMP3,TEMP0,K0MAX,TY1,AU2)
C
	CALL VEC_DMULT_VECTOR(PARTVI,SF,K0MAX,AU3)
C
	CALL VEC_DADD_VECTOR(AU1,AU2,K0MAX,TEMP0)
	TY3 = 1.D0
	CALL VEC_DADD_MULT_CONSTANT(TEMP0,AU3,K0MAX,TY3,SV12)
	RETURN
	END
C*****************************************************	
c part prop. H34(0) in sigma^ir
C*****************************************************	
	SUBROUTINE SSV2resO(S,GPT4,Y3,Y4,X10,X20,X4,U2,
     #	IH1,IH2,IH4,ETA,SV2)
C INTEGRALE A 2 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=32)
	DIMENSION PARTVI2(K0MAX),SF(K0MAX)
	DIMENSION SV2(K0MAX),TEMP(K0MAX)
	PI=4.D0*DATAN(1.D0)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	FI = PI*U2
	PT4 = GPT4/X4
	PT3 = PT4
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL SPARTVI2resO(S,SC,TC,UC,YS,FI,PARTVI2)
	CALL VEC_DMULT_VECTOR(PARTVI2,SF,K0MAX,TEMP)
	TY3 = PI
	CALL VEC_DMULT_CONSTANT(TEMP,K0MAX,TY3,SV2)
c	write (19,*) 'a0:',sv2
	RETURN
	END
C*****************************************************
C soft part (z4=1) of 5||4
C*****************************************************
c change 4.11.02 	
	SUBROUTINE SSV4resO(S,GPT3,GPT4,GPTSUP,Y3,Y4,MF,X10,X20,
     #	IH1,IH2,IH4,ETA,SV4)
C INTEGRALE A 1 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
	common/isophot/iphotisol
	COMMON/COUP_HISTO/R_ISOL,EPSILON_H
	PARAMETER (K0MAX=32)
	DIMENSION PART45Z(K0MAX),PART45L(K0MAX),PART45D(K0MAX),SF(K0MAX)
	DIMENSION SV4(K0MAX),AU4(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	X4=GPT4/GPT3
	PT4 = GPT4/X4
	PT3 = PT4
c	GPT3MAX = DMIN1(GPTSUP,DSQRT(S)/(2.D0*DCOSH(Y3)))
c	IF (iphotisol.eq.0) THEN
c	   X4MINPP = 2.D0*GPT4/DSQRT(S)*DCOSH(Y4)
c	ELSE 
c	X4MIN_INCL = 2.D0*GPT4/DSQRT(S)*DCOSH(Y4)
c	X4MIN_ISOL = 1.D0/(1.D0+EPSILON_H)
c	X4MINPP = DMAX1(X4MIN_INCL,X4MIN_ISOL)
c	ENDIF
c	X4MINP = dmax1(x4minpp,gpt4/gpt3max)
c	Z4MIN = DMAX1(gpt4/gpt3,X10/eta,X20)
	Z4MIN = gpt4/gpt3
	IF (Z4MIN.ge.1.D0) THEN 
	     write(17,*) 'Z4MIN > 1 !',Z4MIN,
     #	             gpt4/gpt3,X10/eta,X20
             RETURN
	 ENDIF   
c
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*GPT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*GPT3*DEXP(Y3)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL SPART45ZresO(SC,TC,UC,UN,MF,PT4,PART45Z)
	CALL SPART45LresO(SC,TC,UC,UN,PART45L)
	CALL SPART45DresO(SC,TC,UC,MF,PT4,PART45D)
	CALL VEC_DMULT_VECTOR(PART45Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART45L,SF,K0MAX,TEMP1)
	CALL VEC_DMULT_VECTOR(PART45D,SF,K0MAX,TEMP2)
	TY1 = DLOG(1-Z4MIN)
	TY2 = DLOG(1-Z4MIN)**2/2.D0
	CALL VEC_DMULT_ADD(TEMP2,TEMP1,K0MAX,TY2,TEMP3)
	CALL VEC_DMULT_ADD(TEMP3,TEMP0,K0MAX,TY1,AU4)
	TY3 = 1.D0
	CALL VEC_DMULT_CONSTANT(AU4,K0MAX,TY3,SV4)
	RETURN
	END
C*****************************************************	
C 5||3 except Log(R^2) part
C****************************************************	
	SUBROUTINE SSV3resO(S,GPT4,Y3,Y4,MF,X10,X20,X4,
     #	IH1,IH2,IH4,ETA,SV3)
C INTEGRALE A 1 DIMENSIONS
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=32)
	DIMENSION PART35D(K0MAX),SF(K0MAX)
	DIMENSION SV3(K0MAX),AU4(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT4 = GPT4/X4
	PT3 = PT4
c
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*PT4*DEXP(Y4)
	UC = -X10*DSQRT(S)*PT4*DEXP(-Y4)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL SPART35DresO(SC,TC,UC,PART35D)
	CALL VEC_DMULT_VECTOR(PART35D,SF,K0MAX,AU4)
	TY4 = 1.D0
	CALL VEC_DMULT_CONSTANT(AU4,K0MAX,TY4,SV3)
	RETURN
	END
C*****************************************************	
C 5||1(z1) - 5||1(1), 5||2(z2)-5||2(1)
C*****************************************************
	SUBROUTINE SSY3resO(S,GPT4,Y3,Y4,M,X10,X20,X4,U2,
     #	IH1,IH2,IH4,ETA,SY3)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/COUP/PTMM,R
	PARAMETER (K0MAX=32)
	DIMENSION PART15Z(K0MAX),PART15L(K0MAX)
	DIMENSION PART15Z0(K0MAX),PART15L0(K0MAX)
	DIMENSION PART25Z(K0MAX),PART25L(K0MAX)
	DIMENSION PART25Z0(K0MAX),PART25L0(K0MAX)
	DIMENSION SF(K0MAX),SF0(K0MAX)
	DIMENSION SY3(K0MAX),BU1(K0MAX),BU2(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	DIMENSION TEMP4(K0MAX),TEMP5(K0MAX),TEMP6(K0MAX),TEMP7(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT4 = GPT4/X4
	PT3 = PT4
	PT5X = DSQRT(S)/(2.D0*DCOSH(YS))*(1.D0-X10)*(1.D0-X20)/
     #  ((1.D0-X10)*DEXP(-Y)+(1.D0-X20)*DEXP(Y))
	PTM = DMIN1(PTMM,PT5X)
cc	PTM = PTMM
	SC = X10*X20*S
	TC = -X10*DSQRT(S)*PT3*DEXP(-Y3)
	UC = -X20*DSQRT(S)*PT3*DEXP(Y3)
	delta = 1.d-8
	Z1MAX = 1.D0
	Z1MIN = x10/ETA
	IF (z1min.ge.z1max) THEN
	   CALL VEC_DINIT(BU1,K0MAX,ZERO)
	   go to 11
	ENDIF    
	Z1 = Z1MIN + (Z1MAX-Z1MIN)*U2
c	
	CALL STRFRAPHO(X10/(ETA*Z1),IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF0)
	CALL SPART15ZresO(SC,TC,UC,Z1,M,PTM,PART15Z)
	CALL SPART15ZresO(SC,TC,UC,UN,M,PTM,PART15Z0)
	CALL SPART15LresO(SC,TC,UC,Z1,PART15L)
	CALL SPART15LresO(SC,TC,UC,UN,PART15L0)
	CALL VEC_DMULT_VECTOR(PART15Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART15Z0,SF0,K0MAX,TEMP1)
	TY1 = 1.D0/Z1**2
	CALL VEC_DMULT_SUB(TEMP1,TEMP0,K0MAX,TY1,TEMP2)
	TY2 = 1.D0/(1.D0-Z1)
	CALL VEC_DMULT_CONSTANT(TEMP2,K0MAX,TY2,TEMP3)
	CALL VEC_DMULT_VECTOR(PART15L,SF,K0MAX,TEMP4)
	CALL VEC_DMULT_VECTOR(PART15L0,SF0,K0MAX,TEMP5)
	CALL VEC_DMULT_SUB(TEMP5,TEMP4,K0MAX,TY1,TEMP6)
	TY3 = DLOG(1.D0-Z1)/(1.D0-Z1)
	CALL VEC_DMULT_CONSTANT(TEMP6,K0MAX,TY3,TEMP7)
	TY4 = (Z1MAX-Z1MIN)
	CALL VEC_DADD_MULT_CONSTANT(TEMP3,TEMP7,K0MAX,TY4,BU1)
c	
  11	Z2MAX = 1.D0
	Z2MIN = X20
	Z2 = Z2MIN + (Z2MAX-Z2MIN)*U2
	CALL STRFRAPHO(X10/ETA,IH1,X20/Z2,IH2,X4,IH4,ETA,SF)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF0)
	CALL SPART25ZresO(SC,TC,UC,Z2,M,PTM,PART25Z)
	CALL SPART25ZresO(SC,TC,UC,UN,M,PTM,PART25Z0)
	CALL SPART25LresO(SC,TC,UC,Z2,PART25L)
	CALL SPART25LresO(SC,TC,UC,UN,PART25L0)
	CALL VEC_DMULT_VECTOR(PART25Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART25Z0,SF0,K0MAX,TEMP1)
	TY1 = 1.D0/Z2**2
	CALL VEC_DMULT_SUB(TEMP1,TEMP0,K0MAX,TY1,TEMP2)
	TY2 = 1.D0/(1.D0-Z2)
	CALL VEC_DMULT_CONSTANT(TEMP2,K0MAX,TY2,TEMP3)
C
	CALL VEC_DMULT_VECTOR(PART25L,SF,K0MAX,TEMP4)
	CALL VEC_DMULT_VECTOR(PART25L0,SF0,K0MAX,TEMP5)
	CALL VEC_DMULT_SUB(TEMP5,TEMP4,K0MAX,TY1,TEMP6)
	TY3 = DLOG(1.D0-Z2)/(1.D0-Z2)
	CALL VEC_DMULT_CONSTANT(TEMP6,K0MAX,TY3,TEMP7)
C
	TY4 = (Z2MAX-Z2MIN)
	CALL VEC_DADD_MULT_CONSTANT(TEMP3,TEMP7,K0MAX,TY4,BU2)
C
	CALL VEC_DADD_VECTOR(BU1,BU2,K0MAX,SY3)
	RETURN
	END
C*****************************************************	
c 5||4(z4) - 5||4(1)
c*****************************************************
c change 4.11.02	
	SUBROUTINE SSY4PresO(S,GPT3,GPT4,Y3,Y4,MF,X10,X20,Z4,
     #	IH1,IH2,IH4,ETA,SY4P)
	IMPLICIT REAL*8 (A-H,L-Z)
	PARAMETER (K0MAX=32)
	DIMENSION PART45Z(K0MAX),PART45L(K0MAX),SF(K0MAX)
	DIMENSION PART45Z0(K0MAX),PART45L0(K0MAX),SF0(K0MAX)
	DIMENSION SY4P(K0MAX)
	DIMENSION TEMP0(K0MAX),TEMP1(K0MAX),TEMP2(K0MAX),TEMP3(K0MAX)
	DIMENSION TEMP4(K0MAX),TEMP5(K0MAX),TEMP6(K0MAX),TEMP7(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	X4 = GPT4/GPT3/Z4
	X4S = GPT4/GPT3
	PT4 = GPT4/X4
	PT4S = GPT4/X4S
c	X1S = X10/Z4
c	X2S = X20/Z4
c juste pour tester (en principe inutile)
	if (x10/eta.gt.un.or.x20.gt.un) then
	  CALL VEC_DINIT(SY4P,K0MAX,ZERO)
	  write (18,*) 'attention x10/eta > 1 ou x20 > 1',
     #	              x10,x20,eta
	  return
	endif
c attention les elements de matrice 2 -> 2 sont independant de 
c l'echelle d'energie
	SC = X10*X20*S
	TC = -X20*DSQRT(S)*GPT3*DEXP(Y4)
	UC = -X10*DSQRT(S)*GPT3*DEXP(-Y4)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4S,IH4,ETA,SF0)
	CALL SPART45ZresO(SC,TC,UC,Z4,MF,PT4,PART45Z)
	CALL SPART45ZresO(SC,TC,UC,UN,MF,PT4S,PART45Z0)
	CALL SPART45LresO(SC,TC,UC,Z4,PART45L)
	CALL SPART45LresO(SC,TC,UC,UN,PART45L0)
C
	CALL VEC_DMULT_VECTOR(PART45Z,SF,K0MAX,TEMP0)
	CALL VEC_DMULT_VECTOR(PART45Z0,SF0,K0MAX,TEMP1)
c	TY1 = 1.D0/Z4**2
        TY1 = 1.D0/Z4
	CALL VEC_DMULT_SUB(TEMP1,TEMP0,K0MAX,TY1,TEMP2)
	TY2 = 1.D0/(1.D0-Z4)
	CALL VEC_DMULT_CONSTANT(TEMP2,K0MAX,TY2,TEMP3)
C
	CALL VEC_DMULT_VECTOR(PART45L,SF,K0MAX,TEMP4)
	CALL VEC_DMULT_VECTOR(PART45L0,SF0,K0MAX,TEMP5)
	CALL VEC_DMULT_SUB(TEMP5,TEMP4,K0MAX,TY1,TEMP6)
	TY3 = DLOG(1.D0-Z4)/(1.D0-Z4)
	CALL VEC_DMULT_CONSTANT(TEMP6,K0MAX,TY3,TEMP7)
C
c	TY4 = GPT4/(X4**2)
        TY4 = 1.D0
	CALL VEC_DADD_MULT_CONSTANT(TEMP3,TEMP7,K0MAX,TY4,SY4P)
	RETURN
	END
C*****************************************************	
C*****************************************************
C TERME A L'ORDRE DE BORN	
C*****************************************************	
	SUBROUTINE SFBORNresO(S,N,GPT4,Y3,Y4,X4,
     #	IH1,IH2,IH4,ETA,FBORN)
	IMPLICIT REAL*8 (A-H,L-Z)
	COMMON/SCALE/M,MF,MU
	PARAMETER (K0MAX=32)
	DIMENSION SF1(K0MAX),RBORN1(K0MAX)
	DIMENSION FBORN(K0MAX),TEMP0(K0MAX)
	ZERO = 0.D0
	UN = 1.D0
	YS = (Y3-Y4)/2.D0
	Y = (Y3+Y4)/2.D0
	PT = GPT4/X4
	X10 = 2.D0*PT/DSQRT(S)*DEXP(Y)*DCOSH(YS)	
	X20 = 2.D0*PT/DSQRT(S)*DEXP(-Y)*DCOSH(YS)
	if (x10/eta.gt.un.or.x20.gt.un) then
	  CALL VEC_DINIT(FBORN,K0MAX,ZERO)
	  return
	endif
	SC = 4.D0*PT**2*DCOSH(YS)**2
	TC = -2.D0*PT**2*DCOSH(YS)*DEXP(-YS)
	UC = -2.D0*PT**2*DCOSH(YS)*DEXP(YS)
	CALL STRFRAPHO(X10/ETA,IH1,X20,IH2,X4,IH4,ETA,SF1)
	CALL BORNresO(SC,TC,UC,N,RBORN1)
	CALL VEC_DMULT_VECTOR(RBORN1,SF1,K0MAX,TEMP0)
	TY3 = 1.D0
	CALL VEC_DMULT_CONSTANT(TEMP0,K0MAX,TY3,FBORN)
	RETURN
	END 
C	
